<?php
/*
Plugin Name: eShop and Affiliate Integration
Version: v1.2
Plugin URI: http://www.tipsandtricks-hq.com/
Author: Ruhul Amin
Author URI: http://www.tipsandtricks-hq.com/
Description: This plugin integrates the WP Affiliate Platfrom with the eShop plugin (by Rich Pedley)!
*/
function wp_aff_eshop_get_referrer()
{
	if (!empty($_SESSION['ap_id']))
	{
	    $referrer = $_SESSION['ap_id'];
	}
	else if (isset($_COOKIE['ap_id']))
	{
	    $referrer = $_COOKIE['ap_id'];
	}	
	return $referrer;
}
function eShop_process_aff_commission_handler($order_details)
{
	$sale_amount = $order_details['sale_amt'];
	$txn_id = $order_details['txn_id'];
	$item_id = '';
	$buyer_email = $order_details['buyer_email'];
	$referrer = $order_details['id'];
        if (empty($referrer))
        {
            $referrer = wp_aff_eshop_get_referrer();
        }
        
	global $wpdb;
	$aff_sales_table = WP_AFF_SALES_TBL_NAME;
	$resultset = $wpdb->get_results("SELECT * FROM $aff_sales_table WHERE txn_id = '$txn_id'", OBJECT);
	if($resultset)
	{
		//Commission for this transaction has already been awarded so no need to do anything.
	}
	else
	{
		if (!empty($referrer))
		{
			if(defined('WP_AFFILIATE_NO_COMMISSION_FOR_SELF_PURCHASE') && WP_AFFILIATE_NO_COMMISSION_FOR_SELF_PURCHASE == '1'){
				wp_affiliate_log_debug("Checking details for the WP_AFFILIATE_NO_COMMISSION_FOR_SELF_PURCHASE option",true);
				if(!empty($buyer_email)){
					if(wp_aff_check_if_buyer_is_referrer($referrer,$buyer_email)){
						wp_affiliate_log_debug('The buyer ('.$buyer_email.') is the referrer ('.$referrer.') so this sale is NOT ELIGIBLE for generating any commission.',true);
						return true;
					}
				}
				else{
					 wp_affiliate_log_debug("Buyer email data is missing from the request so the plugin cannot verify the WP_AFFILIATE_NO_COMMISSION_FOR_SELF_PURCHASE option",true);
				}
			}				
		    wp_aff_award_commission($referrer,$sale_amount,$txn_id,$item_id,$buyer_email);
		}
		else
		{
		    //Not an affiliate conversion
		}
	}
}
add_action('eShop_process_aff_commission','eShop_process_aff_commission_handler');
?>